#ifndef _OPERATOR_H_
#define _OPERATOR_H_

#include <string>
#include <vector>

/**************************************************************************************/
using namespace std;

/**************************************************************************************/
enum Type
{
	BLOCK,
	IF,
	PRINT,
	LET,
	LABEL,
	GOTO,
	WHILE,
	INCLUDE
};

/**************************************************************************************/
class Operator
{
public://////////////////////////////////////////////////////////////////////////

								Operator( 
									Operator* inParent, 
									const Type& inType, 
									const string& inExp,
									const string& inExp2 = "" );

public://////////////////////////////////////////////////////////////////////////

		void					AddChild( Operator* inOperator );

		bool					Execute( void );
		void					Catch( Operator* inOperator );

		Operator*				GetParent( void )				{ return mParent; }
		Type					GetKind( void )					{ return mType; }
		string&					GetData( void )					{ return mExp; }

protected://////////////////////////////////////////////////////////////////////////

		bool					mCached;
		vector<el>				mCache;
		vector<Operator*>		mChild;
		Operator*				mParent;
		Operator*				mCachedGoTo;
		Type					mType;
		string					mExp;
		string					mExp2;
};

#endif // _OPERATOR_H_
